# Couenne::exprDiv Class Reference

class for divisions, More...

`#include <CouenneExprDiv.hpp>`

Inheritance diagram for Couenne::exprDiv:

List of all members.

## Public Member Functions
| exprDiv (expression **al, int n=2)
| Constructor.
| exprDiv (expression *arg0, expression *arg1)
| Constructor with two arguments given explicitly.
expression * | clone (Domain *d=NULL) const
| Cloning method.
std::string | printOp () const
| Print operator.
CouNumber | operator() ()
| Function for the evaluation of the expression.
CouNumber | gradientNorm (const double *x)
| return l-2 norm of gradient at given point
expression * | differentiate (int index)
| Differentiation.
expression * | simplify ()
| Simplification.
int | Linearity ()
| Get a measure of "how linear" the expression is (see CouenneTypes.h).
void | getBounds (expression *&lb, expression *&ub)
| Get lower and upper bound of an expression (if any).
void | getBounds (CouNumber &lb, CouNumber &ub)
| Get value of lower and upper bound of an expression (if any).
exprAux * | standardize (CouenneProblem *p, bool addAux=true)
| Reduce expression in standard form, creating additional aux variables (and constraints).
void | generateCuts (expression *w, OsiCuts &cs, const CouenneCutGenerator *cg, t_chg_bounds *=NULL, int=-1, CouNumber=-COUENNE_INFINITY, CouNumber=COUENNE_INFINITY)
| Generate equality between *this and *w.
virtual enum expr_type | code ()
| Code for comparisons.
bool | isInteger ()
| is this expression integer?
bool | impliedBound (int, CouNumber *, CouNumber *, t_chg_bounds *, enum auxSign=expression::AUX_EQ)
| Implied bound processing.
virtual CouNumber | selectBranch (const CouenneObject *obj, const OsiBranchingInformation *info, expression *&var, double *&brpts, double *&brDist, int &way)
| Set up branching object by evaluating many branching points for each expression's arguments.
virtual void | closestFeasible (expression *varind, expression *vardep, CouNumber &left, CouNumber &right) const
| compute $y^{lv}$ and $y^{uv}$ for Violation Transfer algorithm
virtual bool | isCuttable (CouenneProblem *problem, int index) const
| can this expression be further linearized or are we on its concave ("bad") side

## Detailed Description

class for divisions,

Definition at line 24 of file CouenneExprDiv.hpp.

## Constructor & Destructor Documentation

Couenne::exprDiv::exprDiv | ( | expression ** | al,
|  | int | n = `2` |
| ) |  |  | `[inline]`

Constructor.

Definition at line 29 of file CouenneExprDiv.hpp.

Referenced by clone().

Couenne::exprDiv::exprDiv | ( | expression * | arg0,
|  | expression * | arg1 |
| ) |  |  | `[inline]`

Constructor with two arguments given explicitly.

Definition at line 33 of file CouenneExprDiv.hpp.

## Member Function Documentation

expression* Couenne::exprDiv::clone | ( | Domain * | d = `NULL` | ) | const`[inline, virtual]`

Cloning method.

Reimplemented from Couenne::expression.

Definition at line 37 of file CouenneExprDiv.hpp.

References Couenne::exprOp::clonearglist(), exprDiv(), and Couenne::exprOp::nargs_.

std::string Couenne::exprDiv::printOp | ( |  | ) | const`[inline, virtual]`

Print operator.

Reimplemented from Couenne::exprOp.

Definition at line 41 of file CouenneExprDiv.hpp.

CouNumber Couenne::exprDiv::operator() | ( |  | ) | `[inline, virtual]`

Function for the evaluation of the expression.

Compute division.

Implements Couenne::expression.

Definition at line 115 of file CouenneExprDiv.hpp.

References Couenne::exprOp::arglist_.

CouNumber Couenne::exprDiv::gradientNorm | ( | const double * | x | ) | `[virtual]`

return l-2 norm of gradient at given point

Reimplemented from Couenne::expression.

expression* Couenne::exprDiv::differentiate | ( | int | index | ) | `[virtual]`

Differentiation.

Reimplemented from Couenne::expression.

expression* Couenne::exprDiv::simplify | ( |  | ) | `[virtual]`

Simplification.

Reimplemented from Couenne::exprOp.

int Couenne::exprDiv::Linearity | ( |  | ) | `[inline, virtual]`

Get a measure of "how linear" the expression is (see CouenneTypes.h).

Reimplemented from Couenne::exprOp.

Definition at line 57 of file CouenneExprDiv.hpp.

References Couenne::exprOp::arglist_, Couenne::CONST, Couenne::NONLINEAR, and Couenne::exprOp::Type().

void Couenne::exprDiv::getBounds | ( | expression *& | lb,
|  | expression *& | ub |
| ) |  |  |

Get lower and upper bound of an expression (if any).

void Couenne::exprDiv::getBounds | ( | CouNumber & | lb,
|  | CouNumber & | ub |
| ) |  |  | `[virtual]`

Get value of lower and upper bound of an expression (if any).

Reimplemented from Couenne::expression.

exprAux* Couenne::exprDiv::standardize | ( | CouenneProblem * | p,
|  | bool | addAux = `true` |
| ) |  |  | `[virtual]`

Reduce expression in standard form, creating additional aux variables (and constraints).

Reimplemented from Couenne::exprOp.

void Couenne::exprDiv::generateCuts | ( | expression * | w,
|  | OsiCuts & | cs,
|  | const CouenneCutGenerator * | cg,
|  | t_chg_bounds * | = `NULL`,
|  | int | = `-1`,
|  | CouNumber | = `-COUENNE_INFINITY`,
|  | CouNumber | = `COUENNE_INFINITY` |
| ) |  |  |

Generate equality between *this and *w.

virtual enum expr_type Couenne::exprDiv::code | ( |  | ) | `[inline, virtual]`

Code for comparisons.

Reimplemented from Couenne::exprOp.

Definition at line 82 of file CouenneExprDiv.hpp.

References Couenne::COU_EXPRDIV.

bool Couenne::exprDiv::isInteger | ( |  | ) | `[virtual]`

is this expression integer?

Reimplemented from Couenne::exprOp.

bool Couenne::exprDiv::impliedBound | ( | int | ,
|  | CouNumber * | ,
|  | CouNumber * | ,
|  | t_chg_bounds * | ,
|  | enum | auxSign = `expression::AUX_EQ` |
| ) |  |  | `[virtual]`

Implied bound processing.

Reimplemented from Couenne::expression.

virtual CouNumber Couenne::exprDiv::selectBranch | ( | const CouenneObject * | obj,
|  | const OsiBranchingInformation * | info,
|  | expression *& | var,
|  | double *& | brpts,
|  | double *& | brDist,
|  | int & | way |
| ) |  |  | `[virtual]`

Set up branching object by evaluating many branching points for each expression's arguments.

virtual void Couenne::exprDiv::closestFeasible | ( | expression * | varind,
|  | expression * | vardep,
|  | CouNumber & | left,
|  | CouNumber & | right |
| ) |  |  | const`[virtual]`

compute $y^{lv}$ and $y^{uv}$ for Violation Transfer algorithm

virtual bool Couenne::exprDiv::isCuttable | ( | CouenneProblem * | problem,
|  | int | index |
| ) |  |  | const`[inline, virtual]`

can this expression be further linearized or are we on its concave ("bad") side

Reimplemented from Couenne::expression.

Definition at line 108 of file CouenneExprDiv.hpp.

The documentation for this class was generated from the following file:

- CouenneExprDiv.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines